# Upload Vendor Bill Attachment

POST https://api.letsdeel.com/rest/v2/accounts-payable/vendor-bills/{vendor_bill_id}/attachments
Content-Type: multipart/form-data

Use this endpoint to attach a PDF invoice file to an existing vendor bill entity. Submit the file via multipart/form-data with the file in the request body.
 **Token scopes**: `treasury-vendorbill:write`

Reference: https://developer.deel.com/api/reference/endpoints/treasury/upload-vendor-bill-attachment

## OpenAPI Specification

```yaml
openapi: 3.1.0
info:
  title: Deel HRIS SCIM API
  version: 1.0.0
paths:
  /accounts-payable/vendor-bills/{vendor_bill_id}/attachments:
    post:
      operationId: upload-vendor-bill-attachment
      summary: Upload Vendor Bill Attachment
      description: >-
        Use this endpoint to attach a PDF invoice file to an existing vendor
        bill entity. Submit the file via multipart/form-data with the file in
        the request body.
         **Token scopes**: `treasury-vendorbill:write`
      tags:
        - subpackage_treasury
      parameters:
        - name: vendor_bill_id
          in: path
          description: Vendor bill id to attach the file to
          required: true
          schema:
            type: string
            format: uuid
        - name: Authorization
          in: header
          description: >
            ## Authentication

            The Deel API uses bearer tokens to authenticate requests. All API
            calls must be made over HTTPS — calls over plain HTTP or without
            authentication will fail.


            ```curl

            curl -X GET 'https://api.letsdeel.com/rest/v2/contracts' \
              -H 'Authorization: Bearer YOUR-TOKEN-HERE'
            ```


            [Learn more about authentication](/api/authentication)
          required: true
          schema:
            type: string
      responses:
        '201':
          description: File uploaded successfully
          content:
            application/json:
              schema:
                $ref: >-
                  #/components/schemas/Treasury_uploadVendorBillAttachment_Response_201
        '400':
          description: Bad request - validation error
          content:
            application/json:
              schema:
                $ref: >-
                  #/components/schemas/UploadVendorBillAttachmentRequestBadRequestError
        '401':
          description: Operation failed.
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/ApiErrorContainer'
        '403':
          description: Operation failed.
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/ApiErrorContainer'
        '404':
          description: Vendor bill not found
          content:
            application/json:
              schema:
                $ref: >-
                  #/components/schemas/UploadVendorBillAttachmentRequestNotFoundError
        '500':
          description: Internal server error
          content:
            application/json:
              schema:
                $ref: >-
                  #/components/schemas/UploadVendorBillAttachmentRequestInternalServerError
      requestBody:
        content:
          multipart/form-data:
            schema:
              type: object
              properties:
                data:
                  $ref: >-
                    #/components/schemas/AccountsPayableVendorBillsVendorBillIdAttachmentsPostRequestBodyContentMultipartFormDataSchemaData
              required:
                - data
servers:
  - url: https://api.letsdeel.com/rest/v2
  - url: https://api-staging.letsdeel.com/rest/v2
components:
  schemas:
    AccountsPayableVendorBillsVendorBillIdAttachmentsPostRequestBodyContentMultipartFormDataSchemaData:
      type: object
      properties:
        file:
          type: string
          format: binary
          description: PDF file to upload (max 8MB)
      title: >-
        AccountsPayableVendorBillsVendorBillIdAttachmentsPostRequestBodyContentMultipartFormDataSchemaData
    AccountsPayableVendorBillsVendorBillIdAttachmentsPostResponsesContentApplicationJsonSchemaData:
      type: object
      properties:
        id:
          type: string
          format: uuid
          description: Unique identifier of the uploaded attachment
        created_at:
          type: string
          format: date-time
          description: Creation timestamp
        updated_at:
          type: string
          format: date-time
          description: Last update timestamp
      required:
        - id
        - created_at
        - updated_at
      title: >-
        AccountsPayableVendorBillsVendorBillIdAttachmentsPostResponsesContentApplicationJsonSchemaData
    Treasury_uploadVendorBillAttachment_Response_201:
      type: object
      properties:
        data:
          $ref: >-
            #/components/schemas/AccountsPayableVendorBillsVendorBillIdAttachmentsPostResponsesContentApplicationJsonSchemaData
      required:
        - data
      title: Treasury_uploadVendorBillAttachment_Response_201
    AccountsPayableVendorBillsVendorBillIdAttachmentsPostResponsesContentApplicationJsonSchemaErrorsItems:
      type: object
      properties:
        code:
          type: string
          description: Machine-readable error code
        message:
          type: string
          description: Human-readable explanation
      required:
        - code
        - message
      title: >-
        AccountsPayableVendorBillsVendorBillIdAttachmentsPostResponsesContentApplicationJsonSchemaErrorsItems
    UploadVendorBillAttachmentRequestBadRequestError:
      type: object
      properties:
        errors:
          type: array
          items:
            $ref: >-
              #/components/schemas/AccountsPayableVendorBillsVendorBillIdAttachmentsPostResponsesContentApplicationJsonSchemaErrorsItems
      required:
        - errors
      title: UploadVendorBillAttachmentRequestBadRequestError
    ApiErrorRequest:
      type: object
      properties:
        method:
          type: string
          description: The HTTP method of the failed request
        url:
          type: string
          description: The relative URL of the failed request
        status:
          type: number
          format: double
          description: The status code of the response
        api_req_id:
          type: string
          description: The request ID of the failed request
        docs:
          type: string
          description: >-
            A link to the official documentation for the requested endpoint
            resource
        source:
          type: string
          description: The source handler which produced the returned error
        code:
          type: number
          format: double
          description: The code of the source handler which produced the returned error
      title: ApiErrorRequest
    ApiError:
      type: object
      properties:
        message:
          type: string
          description: A description of the returned error
        path:
          type: string
          description: The JSON path where input validation failed
      title: ApiError
    ApiErrorContainer:
      type: object
      properties:
        request:
          $ref: '#/components/schemas/ApiErrorRequest'
        errors:
          type: array
          items:
            $ref: '#/components/schemas/ApiError'
      title: ApiErrorContainer
    UploadVendorBillAttachmentRequestNotFoundError:
      type: object
      properties:
        errors:
          type: array
          items:
            $ref: >-
              #/components/schemas/AccountsPayableVendorBillsVendorBillIdAttachmentsPostResponsesContentApplicationJsonSchemaErrorsItems
      required:
        - errors
      title: UploadVendorBillAttachmentRequestNotFoundError
    UploadVendorBillAttachmentRequestInternalServerError:
      type: object
      properties:
        errors:
          type: array
          items:
            $ref: >-
              #/components/schemas/AccountsPayableVendorBillsVendorBillIdAttachmentsPostResponsesContentApplicationJsonSchemaErrorsItems
      required:
        - errors
      title: UploadVendorBillAttachmentRequestInternalServerError
  securitySchemes:
    deelToken:
      type: http
      scheme: bearer
      description: >
        ## Authentication

        The Deel API uses bearer tokens to authenticate requests. All API calls
        must be made over HTTPS — calls over plain HTTP or without
        authentication will fail.


        ```curl

        curl -X GET 'https://api.letsdeel.com/rest/v2/contracts' \
          -H 'Authorization: Bearer YOUR-TOKEN-HERE'
        ```


        [Learn more about authentication](/api/authentication)
    oauth2:
      type: http
      scheme: bearer
      description: >-
        Standard OAuth2 security scheme based on
        https://swagger.io/docs/specification/authentication/

```

## SDK Code Examples

```python
import requests

url = "https://api.letsdeel.com/rest/v2/accounts-payable/vendor-bills/9b9fc43a-a90c-4615-ac50-baf1e314b53e/attachments"

payload = "-----011000010111000001101001\r\nContent-Disposition: form-data; name=\"data\"\r\n\r\n{}\r\n-----011000010111000001101001--\r\n"
headers = {
    "Authorization": "Bearer <token>",
    "Content-Type": "multipart/form-data; boundary=---011000010111000001101001"
}

response = requests.post(url, data=payload, headers=headers)

print(response.json())
```

```javascript
const url = 'https://api.letsdeel.com/rest/v2/accounts-payable/vendor-bills/9b9fc43a-a90c-4615-ac50-baf1e314b53e/attachments';
const form = new FormData();
form.append('data', '{}');

const options = {method: 'POST', headers: {Authorization: 'Bearer <token>'}};

options.body = form;

try {
  const response = await fetch(url, options);
  const data = await response.json();
  console.log(data);
} catch (error) {
  console.error(error);
}
```

```go
package main

import (
	"fmt"
	"strings"
	"net/http"
	"io"
)

func main() {

	url := "https://api.letsdeel.com/rest/v2/accounts-payable/vendor-bills/9b9fc43a-a90c-4615-ac50-baf1e314b53e/attachments"

	payload := strings.NewReader("-----011000010111000001101001\r\nContent-Disposition: form-data; name=\"data\"\r\n\r\n{}\r\n-----011000010111000001101001--\r\n")

	req, _ := http.NewRequest("POST", url, payload)

	req.Header.Add("Authorization", "Bearer <token>")

	res, _ := http.DefaultClient.Do(req)

	defer res.Body.Close()
	body, _ := io.ReadAll(res.Body)

	fmt.Println(res)
	fmt.Println(string(body))

}
```

```ruby
require 'uri'
require 'net/http'

url = URI("https://api.letsdeel.com/rest/v2/accounts-payable/vendor-bills/9b9fc43a-a90c-4615-ac50-baf1e314b53e/attachments")

http = Net::HTTP.new(url.host, url.port)
http.use_ssl = true

request = Net::HTTP::Post.new(url)
request["Authorization"] = 'Bearer <token>'
request.body = "-----011000010111000001101001\r\nContent-Disposition: form-data; name=\"data\"\r\n\r\n{}\r\n-----011000010111000001101001--\r\n"

response = http.request(request)
puts response.read_body
```

```java
import com.mashape.unirest.http.HttpResponse;
import com.mashape.unirest.http.Unirest;

HttpResponse<String> response = Unirest.post("https://api.letsdeel.com/rest/v2/accounts-payable/vendor-bills/9b9fc43a-a90c-4615-ac50-baf1e314b53e/attachments")
  .header("Authorization", "Bearer <token>")
  .body("-----011000010111000001101001\r\nContent-Disposition: form-data; name=\"data\"\r\n\r\n{}\r\n-----011000010111000001101001--\r\n")
  .asString();
```

```php
<?php
require_once('vendor/autoload.php');

$client = new \GuzzleHttp\Client();

$response = $client->request('POST', 'https://api.letsdeel.com/rest/v2/accounts-payable/vendor-bills/9b9fc43a-a90c-4615-ac50-baf1e314b53e/attachments', [
  'multipart' => [
    [
        'name' => 'data',
        'contents' => '{}'
    ]
  ]
  'headers' => [
    'Authorization' => 'Bearer <token>',
  ],
]);

echo $response->getBody();
```

```csharp
using RestSharp;

var client = new RestClient("https://api.letsdeel.com/rest/v2/accounts-payable/vendor-bills/9b9fc43a-a90c-4615-ac50-baf1e314b53e/attachments");
var request = new RestRequest(Method.POST);
request.AddHeader("Authorization", "Bearer <token>");
request.AddParameter("undefined", "-----011000010111000001101001\r\nContent-Disposition: form-data; name=\"data\"\r\n\r\n{}\r\n-----011000010111000001101001--\r\n", ParameterType.RequestBody);
IRestResponse response = client.Execute(request);
```

```swift
import Foundation

let headers = ["Authorization": "Bearer <token>"]
let parameters = [
  [
    "name": "data",
    "value": "{}"
  ]
]

let boundary = "---011000010111000001101001"

var body = ""
var error: NSError? = nil
for param in parameters {
  let paramName = param["name"]!
  body += "--\(boundary)\r\n"
  body += "Content-Disposition:form-data; name=\"\(paramName)\""
  if let filename = param["fileName"] {
    let contentType = param["content-type"]!
    let fileContent = String(contentsOfFile: filename, encoding: String.Encoding.utf8)
    if (error != nil) {
      print(error as Any)
    }
    body += "; filename=\"\(filename)\"\r\n"
    body += "Content-Type: \(contentType)\r\n\r\n"
    body += fileContent
  } else if let paramValue = param["value"] {
    body += "\r\n\r\n\(paramValue)"
  }
}

let request = NSMutableURLRequest(url: NSURL(string: "https://api.letsdeel.com/rest/v2/accounts-payable/vendor-bills/9b9fc43a-a90c-4615-ac50-baf1e314b53e/attachments")! as URL,
                                        cachePolicy: .useProtocolCachePolicy,
                                    timeoutInterval: 10.0)
request.httpMethod = "POST"
request.allHTTPHeaderFields = headers
request.httpBody = postData as Data

let session = URLSession.shared
let dataTask = session.dataTask(with: request as URLRequest, completionHandler: { (data, response, error) -> Void in
  if (error != nil) {
    print(error as Any)
  } else {
    let httpResponse = response as? HTTPURLResponse
    print(httpResponse)
  }
})

dataTask.resume()
```